Skip to main content
POST
/
v1
/
paymentIntents
Create a payment intent
curl --request POST \
  --url https://api-sandbox.circle.com/v1/paymentIntents \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "idempotencyKey": "ba943ff1-ca16-49b2-ba55-1057e70ca5c7",
  "paymentMethods": [
    {
      "type": "blockchain"
    }
  ],
  "merchantWalletId": "212000",
  "purposeOfTransfer": "PMT001",
  "type": "continuous",
  "metadata": {
    "customerExternalRef": "INV-2024-001234"
  }
}
'
import requests

url = "https://api-sandbox.circle.com/v1/paymentIntents"

payload = {
"idempotencyKey": "ba943ff1-ca16-49b2-ba55-1057e70ca5c7",
"paymentMethods": [{ "type": "blockchain" }],
"merchantWalletId": "212000",
"purposeOfTransfer": "PMT001",
"type": "continuous",
"metadata": { "customerExternalRef": "INV-2024-001234" }
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
idempotencyKey: 'ba943ff1-ca16-49b2-ba55-1057e70ca5c7',
paymentMethods: [{type: 'blockchain'}],
merchantWalletId: '212000',
purposeOfTransfer: 'PMT001',
type: 'continuous',
metadata: {customerExternalRef: 'INV-2024-001234'}
})
};

fetch('https://api-sandbox.circle.com/v1/paymentIntents', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "data": {
    "id": "8755d0ea-14f9-4259-b092-de23c14b6568",
    "amount": {
      "amount": "3.14",
      "currency": "USD"
    },
    "amountPaid": {
      "amount": "0.00",
      "currency": "USD"
    },
    "settlementCurrency": "USD",
    "paymentMethods": [
      {
        "type": "blockchain",
        "chain": "ETH",
        "address": "0x8381470ED67C3802402dbbFa0058E8871F017A6F"
      }
    ],
    "paymentIds": [],
    "customerExternalRef": "customer-ref-123",
    "timeline": [
      {
        "status": "created",
        "time": "2022-07-21T20:13:35.579331Z"
      }
    ],
    "purposeOfTransfer": "PMT001",
    "expiresOn": "2022-08-04T20:13:35.578678Z",
    "createDate": "2022-07-21T20:13:35.578678Z",
    "updateDate": "2022-07-21T20:19:24.859052Z"
  }
}

Authorizations

Authorization
string
header
required

Bearer authentication header of the form Bearer <token>, where <token> is your auth token.

Body

application/json
idempotencyKey
string<uuid>
required

Universally unique identifier (UUID v4) idempotency key. This key is utilized to ensure exactly-once execution of mutating requests.

Example:

"ba943ff1-ca16-49b2-ba55-1057e70ca5c7"

currency
enum<string>
required

Desired currency for the payment

Available options:
USD,
EUR
settlementCurrency
enum<string>
required

Desired currency for the payments to settle in. This must match the currency used for the payment.

Available options:
USD,
EUR
paymentMethods
object[]
required
merchantWalletId
string
required

Unique system generated identifier for the wallet of the merchant.

Maximum string length: 36
Example:

"212000"

purposeOfTransfer
enum<string>

Payment reason code describing the purpose of the transfer for the payment intent.

Conditionally required: it must be supplied when the entity's legal entity is Circle SG (CIRCLE_SG), or Circle Inc (CIRCLE_INC) with Managed Payments enabled. It is optional for all other legal entities.

PMT006 (Transfer to own account) is not allowed for payment intents. A missing value (when required) or a disallowed/invalid value returns error code INVALID_PURPOSE_OF_TRANSFER.

Available options:
PMT000,
PMT001,
PMT002,
PMT003,
PMT004,
PMT005,
PMT007,
PMT008,
PMT009,
PMT010,
PMT011,
PMT012,
PMT013,
PMT014,
PMT015,
PMT016,
PMT017,
PMT018,
PMT019,
PMT020,
PMT021,
PMT022,
PMT023,
PMT024,
PMT025,
PMT026,
PMT027,
PMT028,
PMT029,
PMT030
Example:

"PMT001"

type
enum<string>
default:continuous

Payment intent type. Defaults to 'continuous' if not specified.

Available options:
continuous
metadata
object

Optional metadata associated with the payment intent.

Response

Successfully created a payment intent.

data
object